#ifndef __Custom_H__
#define __Custom_H__

#include "avisynth.h"
#include "x264/extras/stdint.h"
#include "x264/x264.h"

namespace CustomMatrices {

typedef unsigned char Byte;

class Filter : public GenericVideoFilter
{
   int nWidth, nHeight;

   bool showSize;
   bool showPsnr;

   x264_t *x264;

   x264_picture_t input;
   x264_picture_t output;

   int nFrames;
   
public:
   Filter(PClip child, const char *pszFileName, const char *luma4x4, const char *chroma4x4, const char *luma8x8,
                       const char *pluma4x4, const char *pchroma4x4, const char *pluma8x8, 
                       bool isInter, bool is8x8, int nQuantizer, bool isDeblocking, int nDeblockingStrength,
                       bool showSize, bool showPsnr, IScriptEnvironment *env);
   ~Filter();

   PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);

};

}

#endif
